<template>
    <div v-loading="loading" class="hc-body-loading" element-loading-text="授权登录中...">
        <div v-if="isErrorShow" class="error-page">
            <div :style="`background-image: url(${svg403});`" class="img" />
            <div class="content">
                <h1>403</h1>
                <div class="desc">抱歉，token授权登录异常，请重新进入</div>
                <div class="actions">
                    <el-button block size="large" type="primary" @click="toLoginTap">手动登录</el-button>
                </div>
            </div>
        </div>
    </div>
</template>

<script setup>
import { onMounted, ref } from 'vue'
import { useAppStore } from '~src/store'
import { getTenantID, loginByToken } from '~api/user'
import { useRoute, useRouter } from 'vue-router'
import svg403 from '~src/assets/view/403.svg'
import { setUserAppInfo, setUserTenantInfo } from '~sto/user'
import { getObjVal, getObjValue, isNullES } from 'js-fast-way'
import { getTopUrl } from '~uti/tools'

//初始变量
const router = useRouter()
const useRoutes = useRoute()
const store = useAppStore()

//变量
const loading = ref(true)
const isErrorShow = ref(false)

//渲染完成
onMounted(() => {
    //先清理下缓存
    store.clearStoreData()
    // http://档案的域名/#/auth-token?token=xxxxxxx
    const { token, tenantid } = getObjValue(useRoutes.query)
    if (!isNullES(token)) {
        isErrorShow.value = false
        setLoginByTokenData(token, tenantid)
    } else {
        loading.value = false
        isErrorShow.value = true
    }
})

//获取租户id
const getTenantIdApi = async () => {
    const { data } = await getTenantID(getTopUrl())
    const { id } = await setUserTenantInfo(getObjVal(data))
    return id
}

//设置租户信息
const setLoginByTokenData = async (token, tenant_id) => {
    const tenantIds = await getTenantIdApi()
    const tenantId = tenant_id ? tenant_id : tenantIds
    await loginByTokenApi({ token, tenantId })
}


//请求授权登录
const loginByTokenApi = async (form) => {
    const { error, code, data } = await loginByToken(form)
    const res = getObjVal(data)
    if (!error && code === 200 && res) {
        await setUserAppInfo(res)
        setTimeout(() => {
            loading.value = false
            isErrorShow.value = false
            window?.$message?.success('授权登录成功')
            router.push({
                name: store.homeUrl ?? 'home',
            })
        }, 1500)
    } else {
        window.$message?.error('授权登录失败')
        isErrorShow.value = true
        loading.value = false
    }
}

//跳转登陆
const toLoginTap = () => {
    router.push({ path: '/login' })
}
</script>

<style lang="scss" scoped>
@import "../../styles/error/style.scss";
.hc-body-loading {
    position: relative;
    height: 100%;
    width: 100%;
}
</style>
